local idTweaks, idTweaksModule, idTweaksOptions, SelectOption, RangeOption, Tooltips
do
  local _obj_0 = _G
  idTweaks, idTweaksModule, idTweaksOptions = _obj_0.idTweaks, _obj_0.idTweaksModule, _obj_0.idTweaksOptions
end
do
  local _obj_0 = idTweaksOptions
  SelectOption, RangeOption = _obj_0.SelectOption, _obj_0.RangeOption
end
do
  local _class_0
  local _parent_0 = idTweaksModule
  local _base_0 = {
    set_options = function(self)
      _class_0.__parent.__base.set_options(self)
      self.options:add_option(SelectOption(self, "anchor", "Anchor Key", "Where to anchor the tooltip to", {
        values = {
          ANCHOR_CURSOR = "Cursor Center",
          ANCHOR_CURSOR_LEFT = "Cursor Left",
          ANCHOR_CURSOR_RIGHT = "Cursor Right",
          ANCHOR_TOPLEFT = "Top Left",
          ANCHOR_TOPRIGHT = "Top Right",
          ANCHOR_BOTTOMLEFT = "Bottom Left",
          ANCHOR_BOTTOMRIGHT = "Bottom Right"
        }
      }, { }, "ANCHOR_CURSOR_RIGHT"))
      self.options:add_option(RangeOption(self, "offset_x", "Offset X", "X axis offset", {
        min = -50,
        max = 50,
        step = 1,
        bigStep = 1
      }, { }, 10))
      return self.options:add_option(RangeOption(self, "offset_y", "Offset Y", "Y axis offset", {
        min = -50,
        max = 50,
        step = 1,
        bigStep = 1
      }, { }, 10))
    end,
    enable = function(self)
      self.ace_module:Unhook("GameTooltip_SetDefaultAnchor")
      return self.ace_module:SecureHook("GameTooltip_SetDefaultAnchor", function(...)
        return self:handle_set_default_anchor(...)
      end)
    end,
    disable = function(self)
      return self.ace_module:Unhook("GameTooltip_SetDefaultAnchor")
    end,
    handle_set_default_anchor = function(self, tooltip, self_object)
      return tooltip:SetOwner(self_object, self.db.anchor, self.db.offset_x, self.db.offset_y)
    end
  }
  _base_0.__index = _base_0
  setmetatable(_base_0, _parent_0.__base)
  _class_0 = setmetatable({
    __init = function(self, addon)
      return _class_0.__parent.__init(self, addon, "Tooltips", "AceConsole-3.0", "AceHook-3.0")
    end,
    __base = _base_0,
    __name = "Tooltips",
    __parent = _parent_0
  }, {
    __index = function(cls, name)
      local val = rawget(_base_0, name)
      if val == nil then
        local parent = rawget(cls, "__parent")
        if parent then
          return parent[name]
        end
      else
        return val
      end
    end,
    __call = function(cls, ...)
      local _self_0 = setmetatable({}, _base_0)
      cls.__init(_self_0, ...)
      return _self_0
    end
  })
  _base_0.__class = _class_0
  if _parent_0.__inherited then
    _parent_0.__inherited(_parent_0, _class_0)
  end
  Tooltips = _class_0
end
return idTweaks:add_module(Tooltips(idTweaks))
